Index: trunk/SophyaPI/DemoPIApp/CONTENT
===================================================================
--- trunk/SophyaPI/DemoPIApp/CONTENT	(revision 3436)
+++ trunk/SophyaPI/DemoPIApp/CONTENT	(revision 3436)
@@ -0,0 +1,72 @@
+====== SOPHYA/piapp demo scripts and programs ======
+===============================================================
+              (C) LAL-IN2P3/CNRS   1998-2007 
+              (C) DAPNIA/CEA       1998-2007
+===============================================================
+
+See http://www.sophya.org and the SOPHYA overview manual and piapp 
+user's guide for more information.
+
+1/ script demo.pic and associated demo.ppf data file
+   demo script showing general piapp features 
+csh> spiapp -exec demo
+OR 
+csh> spiapp 
+# Execute the piapp command :
+piapp> exec demo.pic
+
+2/ script tarc.pic 
+  Drawing text, arcs and arrows ...
+piapp> exec demo.pic
+
+3/ fft2d.pic and fft2.cc 
+  c++ execution in piapp 
+piapp> exec fft2d.pic
+
+4/ multicurve.pic
+  Drawing example, superposition of several functions
+piapp> exec multicurve  
+ OR exec multicurve.pic
+
+5/ axel.pic :  Some options for axes
+
+6/ addelts.pic : How to add some graphic objects (circles, rectangles, text) 
+   to a plot, in this case a function plot
+
+7/ pnbpays.pic : How to make and draw a bargraph
+
+8/ resonance.pic : How to make complex plots/drawings , in this case
+   the resonance curve of an harmonic oscillator, using the piapp 
+   scripting capabilities
+
+9/ oh_xva_spring.pic : An other example of complex drawing ...
+
+10/ user.cc : example of function which can be called from piapp
+10.a/ Create the shared/loadable object user.so
+csh> make user.so
+10.b/ in piapp, link the module and call the function
+piapp> link user.so user
+piapp> call user
+#  --> creates NTuple usernt
+# Can be called again [with different arguments]
+piapp> call user aaa 1 2 bbb
+
+
+
+Loadable modules 
+----------------
+piapp capabilities can be extended using loadable modules
+
+11/ exmod.pic , exmodule.cc 
+11.a/ Create the loadable module exmodule.so 
+csh> make exmodule.so 
+11.b/ Execute the script exmod.pic 
+  ---> new commands are added to piapp
+
+12/ exmoddrw.pic exmoddrw.cc 
+csh> make exmoddrw.so 
+ in piapp> exec exmoddrw.pic
+  ---> extends piapp graphic capability by a new drawer
+
+
+
Index: trunk/SophyaPI/DemoPIApp/Makefile
===================================================================
--- trunk/SophyaPI/DemoPIApp/Makefile	(revision 3356)
+++ trunk/SophyaPI/DemoPIApp/Makefile	(revision 3436)
@@ -1,24 +1,26 @@
+#   ---- Makefile for SOPHYA/DemoPIApp module ----
+#  User functions and loadable modules 
 include $(SOPHYABASE)/include/sophyamake.inc
 
-%.so:$(SOPHYAOBJP)%.o 
-%:%.cc
-%:%.o
-%.o:%.cc
-%.o:%.c
-%:%.c
+all : user.so exmodule.so exmoddrw.so
 
-.PRECIOUS: %.so  
+clean : 
+	rm  user.so exmodule.so exmoddrw.so  user.o exmodule.o exmoddrw.o
 
-%:%.so
-	echo $@ " made (.so) "
+user.so: user.o
+	$(CXXDLL) -o  user.so  user.o $(SOPHYAALLSLBLIST)
+user.o : user.cc
+	$(CXXCOMPILE) -c -o user.o user.cc
 
-%.so:$(SOPHYAOBJP)%.o
-	$(CXXLINK) $(CXXTEMPFLG) -shared -o $@ $< $(SOPHYAALLSLBLIST)
+exmodule.so: exmodule.o
+	$(CXXDLL) -o  exmodule.so  exmodule.o $(SOPHYAALLSLBLIST)
+exmodule.o : exmodule.cc
+	$(CXXCOMPILE) -c -o exmodule.o exmodule.cc
 
-$(SOPHYAOBJP)%.o:%.cc 
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@ $<
+exmoddrw.so: exmoddrw.o
+	$(CXXDLL) -o  exmoddrw.so  exmoddrw.o $(SOPHYAALLSLBLIST)
+exmoddrw.o : exmoddrw.cc
+	$(CXXCOMPILE) -c -o exmoddrw.o exmoddrw.cc
 
-$(SOPHYAOBJP)%.o:%.c
-	$(CCOMPILE) -o $@ $< 
 
 dump :
Index: trunk/SophyaPI/DemoPIApp/Makefile.mgr
===================================================================
--- trunk/SophyaPI/DemoPIApp/Makefile.mgr	(revision 3356)
+++ 	(revision )
@@ -1,36 +1,0 @@
-MODULEDECCXXFLAGS := -msg_quiet 
-include $(SOPHYABASEREP)/Include/MakefileUser.h
-LIBS = -L$(SLB) -lPI -lextsophya -lsophya -lm 
-
-ifeq ($(MACHEROS),OSF1)
-LIBS := $(LIBS) -lfor
-endif
-ifeq ($(MACHEROS),Linux)
-LIBS := $(LIBS) -ldl -lg2c
-endif
-
-%.so:$(OBJ)%.o 
-%:%.cc
-%:%.o
-%.o:%.cc
-%.o:%.c
-%:%.c
-
-.PRECIOUS: %.so  
-
-
-%:%.so
-	echo $@ " made (.so) "
-
-%.so:$(OBJ)%.o
-	$(LINK.cc) -shared -o $@ $< $(LIBS)
-
-$(OBJ)%.o:%.cc 
-	$(COMPILE.cc)  -o $@ $<
-
-$(OBJ)%.o:%.c
-	$(COMPILE.c) -c $(CFLAGS)   $(USERFLAGS) -o $@ $< 
-
-dump :
-	echo $(LIBS)
-
Index: trunk/SophyaPI/DemoPIApp/axel.pic
===================================================================
--- trunk/SophyaPI/DemoPIApp/axel.pic	(revision 3436)
+++ trunk/SophyaPI/DemoPIApp/axel.pic	(revision 3436)
@@ -0,0 +1,7 @@
+openppf demo.ppf
+zone 1
+disp h1d 
+setaxelabels 'Axe X - Bins' 'Axe Y - Content' 'blue font=helvetica,bold,16 fixedfontsize'
+newwin
+disp h1d 'finecenteredaxes'
+setaxelabels 'Axe X - Bins' 'Axe Y - Content' 'blue font=helvetica,bold,16 fixedfontsize'
Index: trunk/SophyaPI/DemoPIApp/exmod.pic
===================================================================
--- trunk/SophyaPI/DemoPIApp/exmod.pic	(revision 3356)
+++ trunk/SophyaPI/DemoPIApp/exmod.pic	(revision 3436)
@@ -3,5 +3,5 @@
 traceon
 #  On passe une commande shell pour fabriquer le module
-shell gmake exmodule.so
+# shell make exmodule.so
 # On charge le module
 loadmodule exmodule.so exmodule
Index: trunk/SophyaPI/DemoPIApp/exmoddrw.pic
===================================================================
--- trunk/SophyaPI/DemoPIApp/exmoddrw.pic	(revision 3356)
+++ trunk/SophyaPI/DemoPIApp/exmoddrw.pic	(revision 3436)
@@ -3,5 +3,5 @@
 traceon
 #  On passe une commande shell pour fabriquer le module
-# shell gmake exmoddrw.so
+# shell make exmoddrw.so
 # On charge le module
 loadmodule exmoddrw.so exmoddrw
Index: trunk/SophyaPI/DemoPIApp/tarc.pic
===================================================================
--- trunk/SophyaPI/DemoPIApp/tarc.pic	(revision 3356)
+++ trunk/SophyaPI/DemoPIApp/tarc.pic	(revision 3436)
@@ -2,4 +2,5 @@
 #  Essai de trace d'elements graphiques
 # et d'arcs en particulier 
+zone 1
 drpanel -1 1 -1 1
 addline -2 0 2 0 