Index: /trunk/SophyaLib/Manual/piapp.tex
===================================================================
--- /trunk/SophyaLib/Manual/piapp.tex	(revision 3442)
+++ /trunk/SophyaLib/Manual/piapp.tex	(revision 3443)
@@ -603,6 +603,7 @@
 Graphical representation of most objects in piapp is 
 handled through objects inheriting from the {\bf PIDrawer class}. A base drawer 
-(PIElDrawer, number 0) associated to all three above viewers manages the axes drawing 
-as well as the added graphic elements (text, arrow, \ldots). A drawer management menu 
+({\bf PIElDrawer}, number 0) is associated to the three viewers presented above,
+and manages the axes drawing as well as the added graphic elements 
+(text, arrow, \ldots). A drawer management menu 
 can be activated using {\tt $<$Alt$>$D}. This menu can be used to move and resize
 drawers, or to display a window for changing drawers graphic attributes. 
@@ -636,8 +637,8 @@
 specifying some of the axes attributes, such as color or the font used for 
 drawing the axes. The command {\bf setaxesatt}  (\myppageref{setaxesatt})
-should thus be used to specify generic graphic attributes (color, font, line type). \\
-for axes. 
-\begin{itemize}
-\item[\bul]  The {\bf PIScDrawWdg} viewer options: \\
+should thus be used to specify generic graphic attributes 
+(color, font, line type) for axes. 
+\subsubsection{PIScDrawWdg}
+The {\bf PIScDrawWdg} which handles 2d graphics recognizes the following options: 
 \begin{verbatim}
 >> To define the 2D axes limits (in user coordinates)
@@ -652,5 +653,6 @@
 \end{verbatim}
 %%%
-\item[\bul]  The {\bf PIDraw3DWdg} viewer options: \\
+\subsubsection{PIDraw3DWdg}
+The {\bf PIDraw3DWdg} which handles 3d graphics recognizes the following options:
 \begin{verbatim}
 >> To define the 3D box limits : 
@@ -666,5 +668,6 @@
 \end{verbatim}
 %%%
-\item[\bul]  The {\bf PIImage} viewer options: \\
+\subsubsection{PIImage}
+The {\bf PIImage} which handles image display recognizes the following options: 
 \begin{verbatim}
 >> Define display zoomfactor 
@@ -705,6 +708,7 @@
 \end{verbatim}
 %%% 
-\item[\bul]  The {\bf PIGraphicAtt} Generic graphic attributes (color/font/line \ldots)
-decoded by all drawers: \\
+\subsubsection{PIGraphicAtt}
+The {\bf PIGraphicAtt} Generic graphic attributes (color/font/line \ldots)
+decoded by all drawers: 
 \begin{verbatim}
 >>> color=ColorName - fgcolor=ColorName - bgcolor=ColorName 
@@ -749,5 +753,6 @@
 \end{verbatim}
 %%%%
-\item[\bul]  The {\bf PIElDrawer} decodes axe drawing attributes: \\
+\subsubsection{PIElDrawer}
+The {\bf PIElDrawer} decodes axe drawing attributes: 
 \begin{verbatim}
  >> Axe and grid configuration flags: 
@@ -768,5 +773,5 @@
     
 \end{verbatim}
-\item[\bul]  The {\bf PINTuple} handles most 2D plotting : \\
+The {\bf PINTuple} handles most 2D plotting : \\
 \begin{verbatim}
   sta,stat,stats:            activate   statistic display
@@ -782,6 +787,7 @@
 \end{verbatim}
 %%%
-\item[\bul]  {\bf PIHisto} and {\bf PIHisto2D} handle1D and 2D histograms display. \\
-The following options are recognised by PIHisto: \\
+\subsubsection{PIHisto, PIHisto2D}
+{\bf PIHisto} and {\bf PIHisto2D} handle1D and 2D histograms display. \\
+The following options are recognised by {\bf PIHisto}: \\
 \begin{verbatim}
  ---- PIHisto options help info : 
@@ -803,5 +809,5 @@
 
 \end{verbatim}
-The following options are recognised by PIHisto2D: \\
+The following options are recognised by {\bf PIHisto2D}: \\
 \begin{verbatim}
 - sta,stat,stats:            activate   statistic display
@@ -823,6 +829,7 @@
 \end{verbatim}
 %%%%
-\item[\bul]  The {\bf PINTuple3D} and {\bf PISurfaceDrawer} 
-handles basic 3D plotting and can decode the common 3D box options: \\
+\subsubsection{PINTuple3D , PISurfaceDrawer}
+The {\bf PINTuple3D} and {\bf PISurfaceDrawer} 
+handles basic 3D plotting and can decode the common 3D box options:
 \begin{verbatim}
   X/Y,Z axis rescaling option (-> cubic 3D box)  
@@ -831,5 +838,5 @@
   rescalexy=autoscalexy / norescalexy=noautoscalexy : Z axis 
 \end{verbatim}
-The  PINTuple3D decodes in addition the following options:
+The {\bf PINTuple3D} decodes in addition the following options:
 \begin{verbatim}
  connectpoints: The points are connected by a line 
@@ -839,5 +846,7 @@
   
 \end{verbatim}  
-\item[\bul]  The {\bf (PIContourDrawer)} decodes the following options :  \\
+
+\subsubsection{PIContourDrawer}
+The {\bf PIContourDrawer} decodes the following options :  \\
 \begin{verbatim}
  autolevels : automatic selection of levels and number of contours 
@@ -850,5 +859,7 @@
 \end{verbatim}  
 
-\item[\bul]  {\bf PIBarGraph} options : \\
+\subsubsection{PIBarGraph , PITextDrawer}
+{\bf PIBarGraph} is used by the {\tt bargraph} \myppageref{bargraph}
+command and has the following graphic options:
 \begin{verbatim}
  ---- PIBarGraph options help info : 
@@ -859,5 +870,7 @@
  --- + Usual colr/line/font  attribute decoding ... 
  \end{verbatim}
-\end{itemize}
+The command {\tt textdrawer} \myppageref{textdrawer} uses the 
+{\bf PITextDrawer} which has the following options : \\
+\hspace*{10mm} {\tt frame,noframe: enable/disable frame drawing}
 
 